/**
 * @author santa
 * @created Nov 14, 2008
 */
package search.maze;

import java.awt.Point;
import java.util.PriorityQueue;


public class AStarEngine extends SearchEngine {

    public AStarEngine(Maze m) {
        super(m);
    }

    @Override
    protected Node doSearch() throws PathNotFoundException {
        PriorityQueue<Node> queue = new PriorityQueue<Node>();
        Node current = new Node(maze.getStart(), null);

        queue.offer(current);
        while (!queue.isEmpty()) {
            current = queue.poll();
            if (maze.getValue(current.ref.x, current.ref.y) == Maze.VISITED)
                continue;
            else
                maze.setValue(current.ref.x, current.ref.y, Maze.VISITED);

            if (current.ref.equals(maze.getGoal())) {
                return current;
            } else {
                Point[] moves = maze.getPossibleMoves(current.ref);
                for (Point move : moves) {
                    Node moveNode = new Node(move, current);
                    queue.offer(moveNode);
                }
            }

            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {
            }
        }

        return null;
    }

}
